gtkmm: Gtk::Notebook Class Reference

gtkmm 4.7.1

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gtk::Notebook Class Reference
Widgets | Container Widgets

Container which shows one of its children at a time, in tabbed windows. More...

`#include <gtkmm/notebook.h>`

Inheritance diagram for Gtk::Notebook:
[legend]

## Public Member Functions
| Notebook (Notebook && src) noexcept
Notebook & | operator= (Notebook && src) noexcept
| Notebook (const Notebook &)=delete
Notebook & | operator= (const Notebook &)=delete
| ~Notebook () noexcept override
GtkNotebook * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkNotebook * | gobj () const
| Provides access to the underlying C GObject. More...
| Notebook ()
int | prepend_page (Widget & child, Widget & tab_label)
| Prepends a page to notebook. More...
int | prepend_page (Widget & child)
int | prepend_page (Widget & child, const Glib::ustring & tab_label, bool use_mnemonic=false)
int | prepend_page (Widget & child, Widget & tab_label, Widget & menu_label)
| Prepends a page to notebook, specifying the widget to use as the label in the popup menu. More...
int | prepend_page (Widget & child, const Glib::ustring & tab_label, const Glib::ustring & menu_label, bool use_mnemonic)
int | append_page (Widget & child, Widget & tab_label)
| Appends a page to notebook. More...
int | append_page (Widget & child)
int | append_page (Widget & child, const Glib::ustring & tab_label, bool use_mnemonic=false)
int | append_page (Widget & child, Widget & tab_label, Widget & menu_label)
| Appends a page to notebook, specifying the widget to use as the label in the popup menu. More...
int | append_page (Widget & child, const Glib::ustring & tab_label, const Glib::ustring & menu_label, bool use_mnemonic=false)
int | insert_page (Widget & child, Widget & tab_label, int position)
| Insert a page into notebook at the given position. More...
int | insert_page (Widget & child, int position)
int | insert_page (Widget & child, const Glib::ustring & tab_label, int position, bool use_mnemonic=false)
int | insert_page (Widget & child, Widget & tab_label, Widget & menu_label, int position)
| Insert a page into notebook at the given position, specifying the widget to use as the label in the popup menu. More...
int | insert_page (Widget & child, const Glib::ustring & tab_label, const Glib::ustring & menu_label, int position, bool use_mnemonic=false)
void | remove_page (int page_number=0)
| Removes a page from the notebook given its index in the notebook. More...
void | remove_page (Widget & child)
void | set_group_name (const Glib::ustring & group_name)
| Sets a group name for notebook. More...
Glib::ustring | get_group_name () const
| Gets the current group name for notebook. More...
int | get_current_page () const
| Returns the page number of the current page. More...
Widget * | get_nth_page (int page_number)
| Returns the child widget contained in page number page_number. More...
const Widget * | get_nth_page (int page_number) const
| Returns the child widget contained in page number page_number. More...
int | get_n_pages () const
| Gets the number of pages in a notebook. More...
int | page_num (const Widget & child) const
| Finds the index of the page which contains the given child widget. More...
void | set_current_page (int page_number)
| Switches to the page number page_number. More...
void | next_page ()
| Switches to the next page. More...
void | prev_page ()
| Switches to the previous page. More...
void | set_show_border (bool show_border=true)
| Sets whether a bevel will be drawn around the notebook pages. More...
bool | get_show_border () const
| Returns whether a bevel will be drawn around the notebook pages. More...
void | set_show_tabs (bool show_tabs=true)
| Sets whether to show the tabs for the notebook or not. More...
bool | get_show_tabs () const
| Returns whether the tabs of the notebook are shown. More...
void | set_tab_pos (PositionType pos)
| Sets the edge at which the tabs are drawn. More...
PositionType | get_tab_pos () const
| Gets the edge at which the tabs are drawn. More...
void | set_scrollable (bool scrollable=true)
| Sets whether the tab label area will have arrows for scrolling if there are too many tabs to fit in the area. More...
bool | get_scrollable () const
| Returns whether the tab label area has arrows for scrolling. More...
void | popup_enable ()
| Enables the popup menu. More...
void | popup_disable ()
| Disables the popup menu. More...
Widget * | get_tab_label (Widget & child)
| Returns the tab label widget for the page child. More...
const Widget * | get_tab_label (Widget & child) const
| Returns the tab label widget for the page child. More...
void | set_tab_label (Widget & child, Widget & tab_label)
| Changes the tab label for child. More...
void | set_tab_label_text (Widget & child, const Glib::ustring & tab_text)
| Creates a new label and sets it as the tab label for the page containing child. More...
Glib::ustring | get_tab_label_text (Widget & child) const
| Retrieves the text of the tab label for the page containing child. More...
Widget * | get_menu_label (Widget & child)
| Retrieves the menu label widget of the page containing child. More...
const Widget * | get_menu_label (Widget & child) const
| Retrieves the menu label widget of the page containing child. More...
void | set_menu_label (Widget & child, Widget & menu_label)
| Changes the menu label for the page containing child. More...
void | set_menu_label_text (Widget & child, const Glib::ustring & menu_text)
| Creates a new label and sets it as the menu label of child. More...
Glib::ustring | get_menu_label_text (Widget & child) const
| Retrieves the text of the menu label for the page containing child. More...
void | reorder_child (Widget & child, int position)
| Reorders the page containing child, so that it appears in position position. More...
bool | get_tab_reorderable (Widget & child) const
| Gets whether the tab can be reordered via drag and drop or not. More...
void | set_tab_reorderable (Widget & child, bool reorderable=true)
| Sets whether the notebook tab can be reordered via drag and drop or not. More...
bool | get_tab_detachable (Widget & child) const
| Returns whether the tab contents can be detached from notebook. More...
void | set_tab_detachable (Widget & child, bool detachable=true)
| Sets whether the tab can be detached from notebook to another notebook or widget. More...
void | detach_tab (Widget & child)
| Removes the child from the notebook. More...
Widget * | get_action_widget (PackType pack_type=PackType::START)
| Gets one of the action widgets. More...
void | set_action_widget (Widget * widget, PackType pack_type=PackType::START)
| Sets widget as one of the action widgets. More...
Glib::RefPtr< NotebookPage > | get_page (Widget & child)
| Returns the `Gtk::NotebookPage` for child. More...
Glib::RefPtr< const NotebookPage > | get_page (const Widget & child) const
| Returns the `Gtk::NotebookPage` for child. More...
Glib::RefPtr< Gio::ListModel > | get_pages ()
| Returns a `Gio::ListModel` that contains the pages of the notebook. More...
Glib::RefPtr< const Gio::ListModel > | get_pages () const
| Returns a `Gio::ListModel` that contains the pages of the notebook. More...
Glib::SignalProxy< void(Widget *, guint)> | signal_switch_page ()
Glib::SignalProxy< void(Widget *, guint)> | signal_page_reordered ()
Glib::SignalProxy< void(Widget *, guint)> | signal_page_removed ()
Glib::SignalProxy< void(Widget *, guint)> | signal_page_added ()
Glib::PropertyProxy< PositionType > | property_tab_pos ()
| Which side of the notebook holds the tabs. More...
Glib::PropertyProxy_ReadOnly< PositionType > | property_tab_pos () const
| Which side of the notebook holds the tabs. More...
Glib::PropertyProxy< bool > | property_show_tabs ()
| Whether tabs should be shown. More...
Glib::PropertyProxy_ReadOnly< bool > | property_show_tabs () const
| Whether tabs should be shown. More...
Glib::PropertyProxy< bool > | property_show_border ()
| Whether the border should be shown. More...
Glib::PropertyProxy_ReadOnly< bool > | property_show_border () const
| Whether the border should be shown. More...
Glib::PropertyProxy< bool > | property_scrollable ()
| If `true`, scroll arrows are added if there are too many pages to fit. More...
Glib::PropertyProxy_ReadOnly< bool > | property_scrollable () const
| If `true`, scroll arrows are added if there are too many pages to fit. More...
Glib::PropertyProxy< int > | property_page ()
| The index of the current page. More...
Glib::PropertyProxy_ReadOnly< int > | property_page () const
| The index of the current page. More...
Glib::PropertyProxy< Glib::ustring > | property_group_name ()
| Group name for tab drag and drop. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_group_name () const
| Group name for tab drag and drop. More...
Glib::PropertyProxy< bool > | property_enable_popup ()
| If `true`, pressing the right mouse button on the notebook shows a page switching menu. More...
Glib::PropertyProxy_ReadOnly< bool > | property_enable_popup () const
| If `true`, pressing the right mouse button on the notebook shows a page switching menu. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ListModel > > | property_pages () const
| A selection model with the pages. More...
Public Member Functions inherited from Gtk::Widget
| Widget (Widget && src) noexcept
Widget & | operator= (Widget && src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget. More...
GtkWidget * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget. More...
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget. More...
void | show ()
| Flags a widget to be displayed. More...
void | hide ()
| Reverses the effects of show(). More...
void | queue_draw ()
| Schedules this widget to be redrawn in the paint phase of the current or the next frame. More...
void | queue_resize ()
| Flags a widget to have its size renegotiated. More...
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function. More...
void | size_allocate (const Allocation & allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation. More...
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout. More...
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size. More...
void | get_preferred_size (Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management. More...
void | set_layout_manager (const Glib::RefPtr< LayoutManager > & layout_manager)
| Sets the layout manager delegate instance that provides an implementation for measuring and allocating the children of widget. More...
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager(). More...
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager used by widget. More...
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager used by widget. More...
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal. More...
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them. More...
void | set_can_focus (bool can_focus=true)
| Specifies whether the input focus can enter the widget or any of its children. More...
bool | get_can_focus () const
| Determines whether the input focus can enter widget or any of its children. More...
void | set_focusable (bool focusable=true)
| Specifies whether widget can own the input focus. More...
bool | get_focusable () const
| Determines whether widget can own the input focus. More...
bool | has_focus () const
| Determines if the widget has the global input focus. More...
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel. More...
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus. More...
bool | grab_focus ()
| Causes widget to have the keyboard focus for the `Gtk::Window` it's inside. More...
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse. More...
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse. More...
void | set_can_target (bool can_target=true)
| Sets whether widget can be the target of pointer events. More...
bool | get_can_target () const
| Queries whether widget can be the target of pointer events. More...
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel. More...
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
void | set_name (const Glib::ustring & name)
| Sets a widgets name. More...
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget. More...
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state. More...
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state. More...
StateFlags | get_state_flags () const
| Returns the widget state as a flag set. More...
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget. More...
bool | get_sensitive () const
| Returns the widget’s sensitivity. More...
bool | is_sensitive () const
| Returns the widget’s effective sensitivity. More...
void | set_visible (bool visible=true)
| Sets the visibility state of widget. More...
bool | get_visible () const
| Determines whether the widget is visible. More...
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible. More...
bool | is_drawable () const
| Determines whether widget can be drawn to. More...
bool | get_realized () const
| Determines whether widget is realized. More...
bool | get_mapped () const
| Whether the widget is mapped. More...
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its parent. More...
bool | get_child_visible () const
| Gets the value set with set_child_visible(). More...
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget. More...
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget. More...
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget. More...
Allocation | get_allocation () const
| Retrieves the widget’s location. More...
int | get_width () const
| Returns the content width of the widget. More...
int | get_height () const
| Returns the content height of the widget. More...
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget. More...
Widget * | get_parent ()
| Returns the parent widget of widget. More...
const Widget * | get_parent () const
| Returns the parent widget of widget. More...
Root * | get_root ()
| Returns the `Gtk::Root` widget of widget. More...
const Root * | get_root () const
| Returns the `Gtk::Root` widget of widget. More...
Native * | get_native ()
| Returns the nearest `Gtk::Native` ancestor of widget. More...
const Native * | get_native () const
| Returns the nearest `Gtk::Native` ancestor of widget. More...
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts. More...
bool | keynav_failed (DirectionType direction)
| Emits the `::keynav-failed` signal on the widget. More...
void | error_bell ()
| Notifies the user about an input-related error on this widget. More...
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget. More...
void | get_size_request (int & width, int & height) const
| Gets the size request that was explicitly set for the widget using set_size_request(). More...
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent. More...
double | get_opacity () const
| #Fetches the requested opacity for this widget. More...
void | set_overflow (Overflow overflow)
| Sets how widget treats content that is drawn outside the widget's content area. More...
Overflow | get_overflow () const
| Returns the widgets overflow value. More...
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type. More...
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type. More...
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the `Gdk::Display` for the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the `Gdk::Display` for the toplevel window associated with this widget. More...
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget. More...
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for widget. More...
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for widget. More...
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of widget. More...
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of widget. More...
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space. More...
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space. More...
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used. More...
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space. More...
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space. More...
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used. More...
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible. More...
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions. More...
Align | get_halign () const
| Gets the horizontal alignment of widget. More...
void | set_halign (Align align)
| Sets the horizontal alignment of widget. More...
Align | get_valign () const
| Gets the vertical alignment of widget. More...
void | set_valign (Align align)
| Sets the vertical alignment of widget. More...
int | get_margin_start () const
| Gets the start margin of widget. More...
void | set_margin_start (int margin)
| Sets the start margin of widget. More...
int | get_margin_end () const
| Gets the end margin of widget. More...
void | set_margin_end (int margin)
| Sets the end margin of widget. More...
int | get_margin_top () const
| Gets the top margin of widget. More...
void | set_margin_top (int margin)
| Sets the top margin of widget. More...
int | get_margin_bottom () const
| Gets the bottom margin of widget. More...
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget. More...
void | set_margin (int margin)
| Set all 4 margins to the same value. More...
bool | is_ancestor (Widget & ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers. More...
bool | translate_coordinates (Widget & dest_widget, double src_x, double src_y, double & dest_x, double & dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations. More...
bool | contains (double x, double y) const
| Tests if the point at ( x, y) is contained in widget. More...
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of widget closest to the point ( x, y). More...
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of widget closest to the point ( x, y). More...
void | add_controller (const Glib::RefPtr< EventController > & controller)
| Adds controller to widget so that it will receive events. More...
void | remove_controller (const Glib::RefPtr< EventController > & controller)
| Removes controller from widget, so that it doesn't process events anymore. More...
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new `Pango::Context` with the appropriate font map, font options, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a `Pango::Context` with the appropriate font map, font description, and base direction for this widget. More...
void | set_font_options (const Cairo::FontOptions & options)
| Sets the `cairo_font_options_t` used for Pango rendering in this widget. More...
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options(). More...
Cairo::FontOptions | get_font_options () const
| Returns the `cairo_font_options_t` of widget. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring & text)
| Creates a new `Pango::Layout` with the appropriate font map, font description, and base direction for drawing text for this widget. More...
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget. More...
TextDirection | get_direction () const
| Gets the reading direction for a particular widget. More...
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > & cursor)
| Sets the cursor to be shown when pointer devices point towards widget. More...
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget. More...
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Queries the cursor set on widget. More...
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Queries the cursor set on widget. More...
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic. More...
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic. More...
void | add_mnemonic_label (Widget & label)
| Adds a widget to the list of mnemonic labels for this widget. More...
void | remove_mnemonic_label (Widget & label)
| Removes a widget from the list of mnemonic labels for this widget. More...
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold. More...
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget. More...
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget. More...
void | set_parent (Widget & parent)
| Sets parent as the parent widget of widget. More...
void | unparent ()
| Dissociate widget from its parent. More...
void | map ()
| Causes a widget to be mapped if it isn’t already. More...
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped. More...
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located. More...
void | set_tooltip_text (const Glib::ustring & text)
| Sets text as the contents of the tooltip. More...
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget. More...
void | set_tooltip_markup (const Glib::ustring & markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language. More...
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget. More...
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the `has-tooltip` property on widget to has_tooltip. More...
bool | get_has_tooltip () const
| Returns the current value of the `has-tooltip` property. More...
bool | in_destruction () const
| Returns whether the widget is currently being destroyed. More...
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget. More...
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to widget. More...
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame. More...
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback(). More...
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts group into widget. More...
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget. More...
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase & args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it. More...
void | activate_default ()
| Activates the `default.activate` action from widget. More...
void | set_font_map (const Glib::RefPtr< Pango::FontMap > & font_map)
| Sets the font map to use for Pango rendering. More...
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of widget. More...
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of widget. More...
Widget * | get_first_child ()
| Returns the widgets first child. More...
const Widget * | get_first_child () const
| Returns the widgets first child. More...
Widget * | get_last_child ()
| Returns the widgets last child. More...
const Widget * | get_last_child () const
| Returns the widgets last child. More...
Widget * | get_next_sibling ()
| Returns the widgets next sibling. More...
const Widget * | get_next_sibling () const
| Returns the widgets next sibling. More...
Widget * | get_prev_sibling ()
| Returns the widgets previous sibling. More...
const Widget * | get_prev_sibling () const
| Returns the widgets previous sibling. More...
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a `Gio::ListModel` to track the children of widget. More...
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a `Gio::ListModel` to track the children of widget. More...
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget. More...
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget. More...
void | insert_after (Widget & parent, const Widget & previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling. More...
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling. More...
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent. More...
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent. More...
void | snapshot_child (Widget & child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshot the a child of widget. More...
bool | should_layout () const
| Returns whether widget should contribute to the measuring and allocation of its parent. More...
Glib::ustring | get_css_name () const
| Returns the CSS name that is used for self. More...
void | add_css_class (const Glib::ustring & css_class)
| Adds a style class to widget. More...
void | remove_css_class (const Glib::ustring & css_class)
| Removes a style from widget. More...
bool | has_css_class (const Glib::ustring & css_class) const
| Returns whether css_class is currently applied to widget. More...
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to widget. More...
void | set_css_classes (const std::vector< Glib::ustring > & classes)
| Clear all style classes applied to widget and replace them with classes. More...
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen. More...
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget. More...
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase. More...
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget. More...
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The `Gtk::Root` widget of the widget tree containing this widget. More...
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget. More...
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input. More...
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus. More...
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events. More...
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget. More...
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused. More...
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget. More...
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space. More...
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space. More...
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space. More...
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space. More...
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget. More...
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget. More...
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally. More...
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the `hexpand` property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the `hexpand` property. More...
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically. More...
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the `vexpand` property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the `vexpand` property. More...
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget. More...
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget. More...
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated. More...
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated. More...
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree. More...
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget. More...
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget. More...
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children. More...
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible && src) noexcept
Accessible & | operator= (Accessible && src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject. More...
Role | get_accessible_role () const
| Retrieves the `Gtk::Accessible::Role` for the given `Gtk::Accessible`. More...
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state. More...
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property. More...
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation. More...
void | reset_state (State state)
| Resets the accessible state to its default value. More...
void | reset_property (Property property)
| Resets the accessible property to its default value. More...
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value. More...
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given `Gtk::Accessible` implementation. More...
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given `Gtk::Accessible` implementation. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object. More...
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget && src) noexcept
ConstraintTarget & | operator= (ConstraintTarget && src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets. More...
static TextDirection | get_default_direction ()
| Obtains the current default reading direction. More...
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Gtk::Notebook * | wrap (GtkNotebook * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Widget
using | SlotTick = sigc::slot< bool(const Glib::RefPtr< Gdk::FrameClock > &)>
| Callback type for adding a function to update animations. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::Accessible
enum class | Role { ALERT , ALERT_DIALOG , BANNER , BUTTON , CAPTION , CELL , CHECKBOX , COLUMN_HEADER , COMBO_BOX , COMMAND , COMPOSITE , DIALOG , DOCUMENT , FEED , FORM , GENERIC , GRID , GRID_CELL , GROUP , HEADING , IMG , INPUT , LABEL , LANDMARK , LEGEND , LINK , LIST , LIST_BOX , LIST_ITEM , LOG , MAIN , MARQUEE , MATH , METER , MENU , MENU_BAR , MENU_ITEM , MENU_ITEM_CHECKBOX , MENU_ITEM_RADIO , NAVIGATION , NONE , NOTE , OPTION , PRESENTATION , PROGRESS_BAR , RADIO , RADIO_GROUP , RANGE , REGION , ROW , ROW_GROUP , ROW_HEADER , SCROLLBAR , SEARCH , SEARCH_BOX , SECTION , SECTION_HEAD , SELECT , SEPARATOR , SLIDER , SPIN_BUTTON , STATUS , STRUCTURE , SWITCH , TAB , TABLE , TAB_LIST , TAB_PANEL , TEXT_BOX , TIME , TIMER , TOOLBAR , TOOLTIP , TREE , TREE_GRID , TREE_ITEM , WIDGET , WINDOW }
| The accessible role for a Gtk::Accessible implementation. More...
enum class | State { BUSY , CHECKED , DISABLED , EXPANDED , HIDDEN , INVALID , PRESSED , SELECTED }
| The possible accessible states of a Gtk::Accessible. More...
enum class | Property { AUTOCOMPLETE , DESCRIPTION , HAS_POPUP , KEY_SHORTCUTS , LABEL , LEVEL , MODAL , MULTI_LINE , MULTI_SELECTABLE , ORIENTATION , PLACEHOLDER , READ_ONLY , REQUIRED , ROLE_DESCRIPTION , SORT , VALUE_MAX , VALUE_MIN , VALUE_NOW , VALUE_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum class | Relation { ACTIVE_DESCENDANT , COL_COUNT , COL_INDEX , COL_INDEX_TEXT , COL_SPAN , CONTROLS , DESCRIBED_BY , DETAILS , ERROR_MESSAGE , FLOW_TO , LABELLED_BY , OWNS , POS_IN_SET , ROW_COUNT , ROW_INDEX , ROW_INDEX_TEXT , ROW_SPAN , SET_SIZE }
| The possible accessible relations of a Gtk::Accessible. More...
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget * child)
| Sets the focused child of widget. More...
virtual void | compute_expand_vfunc (bool & hexpand_p, bool & vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget. More...
void | unrealize ()
| Causes a widget to be unrealized (frees all GDK resources associated with the widget). More...
void | realize_if_needed ()
void | set_focus_child (Widget & child)
| Set child as the current focus child of widget. More...
void | unset_focus_child ()
| Unsets the focus child of the widget. More...
Widget * | get_focus_child ()
| Returns the current focus child of widget. More...
const Widget * | get_focus_child () const
| Returns the current focus child of widget. More...
virtual void | on_show ()
| This is a default handler for the signal signal_show(). More...
virtual void | on_hide ()
| This is a default handler for the signal signal_hide(). More...
virtual void | on_map ()
| This is a default handler for the signal signal_map(). More...
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap(). More...
virtual void | on_realize ()
| This is a default handler for the signal signal_realize(). More...
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize(). More...
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed(). More...
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed(). More...
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate(). More...
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > & tooltip)
| This is a default handler for the signal signal_query_tooltip(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it. More...

## Detailed Description

Container which shows one of its children at a time, in tabbed windows.

The Gtk::Notebook widget is a layout container whose children are pages that can be switched between using tab labels along one edge.

A Notebook widget looks like this:

## Constructor & Destructor Documentation

## ◆ Notebook() [1/3]

Gtk::Notebook::Notebook | ( | Notebook && | src | ) |
| noexcept

## ◆ Notebook() [2/3]

Gtk::Notebook::Notebook | ( | const Notebook & |  | ) |
| delete

## ◆ ~Notebook()

Gtk::Notebook::~Notebook | ( |  | ) |
| overridenoexcept

## ◆ Notebook() [3/3]

Gtk::Notebook::Notebook | ( |  | ) |

## Member Function Documentation

## ◆ append_page() [1/5]

int Gtk::Notebook::append_page | ( | Widget & | child | ) |

## ◆ append_page() [2/5]

int Gtk::Notebook::append_page | ( | Widget & | child,
|  | const Glib::ustring & | tab_label,
|  | bool | use_mnemonic = `false`
| ) |  |

## ◆ append_page() [3/5]

int Gtk::Notebook::append_page | ( | Widget & | child,
|  | const Glib::ustring & | tab_label,
|  | const Glib::ustring & | menu_label,
|  | bool | use_mnemonic = `false`
| ) |  |

## ◆ append_page() [4/5]

int Gtk::Notebook::append_page | ( | Widget & | child,
|  | Widget & | tab_label
| ) |  |

Appends a page to notebook.

Parameters

  child | The Gtk::Widget to use as the contents of the page.
  tab_label | The Gtk::Widget to be used as the label for the page.

## ◆ append_page() [5/5]

int Gtk::Notebook::append_page | ( | Widget & | child,
|  | Widget & | tab_label,
|  | Widget & | menu_label
| ) |  |

Appends a page to notebook, specifying the widget to use as the label in the popup menu.

Parameters

  child | The Gtk::Widget to use as the contents of the page.
  tab_label | The Gtk::Widget to be used as the label for the page.
  menu_label | The widget to use as a label for the page-switch menu.

## ◆ detach_tab()

void Gtk::Notebook::detach_tab | ( | Widget & | child | ) |

Removes the child from the notebook.

This function is very similar to remove_page(), but additionally informs the notebook that the removal is happening as part of a tab DND operation, which should not be cancelled.

Parameters

  child | A child.

## ◆ get_action_widget()

Widget* Gtk::Notebook::get_action_widget | ( | PackType | pack_type = `PackType::START` | ) |

Gets one of the action widgets.

See set_action_widget().

Parameters

  pack_type | Pack type of the action widget to receive.

Returns
  The action widget with the given pack_type or `nullptr` when this action widget has not been set.

## ◆ get_current_page()

int Gtk::Notebook::get_current_page | ( |  | ) | const

Returns the page number of the current page.

Returns
  The index (starting from 0) of the current page in the notebook. If the notebook has no pages, then -1 will be returned.

## ◆ get_group_name()

Glib::ustring Gtk::Notebook::get_group_name | ( |  | ) | const

Gets the current group name for notebook.

Returns
  The group name, or `nullptr` if none is set.

## ◆ get_menu_label() [1/2]

Widget* Gtk::Notebook::get_menu_label | ( | Widget & | child | ) |

Retrieves the menu label widget of the page containing child.

Parameters

  child | A widget contained in a page of notebook.

Returns
  The menu label, or `nullptr` if the notebook page does not have a menu label other than the default (the tab label).

## ◆ get_menu_label() [2/2]

const Widget* Gtk::Notebook::get_menu_label | ( | Widget & | child | ) | const

Retrieves the menu label widget of the page containing child.

Parameters

  child | A widget contained in a page of notebook.

Returns
  The menu label, or `nullptr` if the notebook page does not have a menu label other than the default (the tab label).

## ◆ get_menu_label_text()

Glib::ustring Gtk::Notebook::get_menu_label_text | ( | Widget & | child | ) | const

Retrieves the text of the menu label for the page containing child.

Parameters

  child | The child widget of a page of the notebook.

Returns
  The text of the tab label.

## ◆ get_n_pages()

int Gtk::Notebook::get_n_pages | ( |  | ) | const

Gets the number of pages in a notebook.

Returns
  The number of pages in the notebook.

## ◆ get_nth_page() [1/2]

Widget* Gtk::Notebook::get_nth_page | ( | int | page_number | ) |

Returns the child widget contained in page number page_number.

Parameters

  page_number | The index of a page in the notebook, or -1 to get the last page.

Returns
  The child widget, or `nullptr` if page_number is out of bounds.

## ◆ get_nth_page() [2/2]

const Widget* Gtk::Notebook::get_nth_page | ( | int | page_number | ) | const

Returns the child widget contained in page number page_number.

Parameters

  page_number | The index of a page in the notebook, or -1 to get the last page.

Returns
  The child widget, or `nullptr` if page_number is out of bounds.

## ◆ get_page() [1/2]

Glib::RefPtr<const NotebookPage> Gtk::Notebook::get_page | ( | const Widget & | child | ) | const

Returns the `Gtk::NotebookPage` for child.

Parameters

  child | A child of notebook.

Returns
  The `Gtk::NotebookPage` for child.

## ◆ get_page() [2/2]

Glib::RefPtr<NotebookPage> Gtk::Notebook::get_page | ( | Widget & | child | ) |

Returns the `Gtk::NotebookPage` for child.

Parameters

  child | A child of notebook.

Returns
  The `Gtk::NotebookPage` for child.

## ◆ get_pages() [1/2]

Glib::RefPtr<Gio::ListModel> Gtk::Notebook::get_pages | ( |  | ) |

Returns a `Gio::ListModel` that contains the pages of the notebook.

This can be used to keep an up-to-date view. The model also implements Gtk::SelectionModel and can be used to track and modify the visible page.

Returns
  A `Gio::ListModel` for the notebook's children.

## ◆ get_pages() [2/2]

Glib::RefPtr<const Gio::ListModel> Gtk::Notebook::get_pages | ( |  | ) | const

Returns a `Gio::ListModel` that contains the pages of the notebook.

This can be used to keep an up-to-date view. The model also implements Gtk::SelectionModel and can be used to track and modify the visible page.

Returns
  A `Gio::ListModel` for the notebook's children.

## ◆ get_scrollable()

bool Gtk::Notebook::get_scrollable | ( |  | ) | const

Returns whether the tab label area has arrows for scrolling.

Returns
  `true` if arrows for scrolling are present.

## ◆ get_show_border()

bool Gtk::Notebook::get_show_border | ( |  | ) | const

Returns whether a bevel will be drawn around the notebook pages.

Returns
  `true` if the bevel is drawn.

## ◆ get_show_tabs()

bool Gtk::Notebook::get_show_tabs | ( |  | ) | const

Returns whether the tabs of the notebook are shown.

Returns
  `true` if the tabs are shown.

## ◆ get_tab_detachable()

bool Gtk::Notebook::get_tab_detachable | ( | Widget & | child | ) | const

Returns whether the tab contents can be detached from notebook.

Parameters

  child | A child `Gtk::Widget`.

Returns
  `true` if the tab is detachable.

## ◆ get_tab_label() [1/2]

Widget* Gtk::Notebook::get_tab_label | ( | Widget & | child | ) |

Returns the tab label widget for the page child.

`nullptr` is returned if child is not in notebook or if no tab label has specifically been set for child.

Parameters

  child | The page.

Returns
  The tab label.

## ◆ get_tab_label() [2/2]

const Widget* Gtk::Notebook::get_tab_label | ( | Widget & | child | ) | const

Returns the tab label widget for the page child.

`nullptr` is returned if child is not in notebook or if no tab label has specifically been set for child.

Parameters

  child | The page.

Returns
  The tab label.

## ◆ get_tab_label_text()

Glib::ustring Gtk::Notebook::get_tab_label_text | ( | Widget & | child | ) | const

Retrieves the text of the tab label for the page containing child.

Parameters

  child | A widget contained in a page of notebook.

Returns
  The text of the tab label.

## ◆ get_tab_pos()

PositionType Gtk::Notebook::get_tab_pos | ( |  | ) | const

Gets the edge at which the tabs are drawn.

Returns
  The edge at which the tabs are drawn.

## ◆ get_tab_reorderable()

bool Gtk::Notebook::get_tab_reorderable | ( | Widget & | child | ) | const

Gets whether the tab can be reordered via drag and drop or not.

Parameters

  child | A child `Gtk::Widget`.

Returns
  `true` if the tab is reorderable.

## ◆ get_type()

static GType Gtk::Notebook::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkNotebook* Gtk::Notebook::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkNotebook* Gtk::Notebook::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ insert_page() [1/5]

int Gtk::Notebook::insert_page | ( | Widget & | child,
|  | const Glib::ustring & | tab_label,
|  | const Glib::ustring & | menu_label,
|  | int | position,
|  | bool | use_mnemonic = `false`
| ) |  |

## ◆ insert_page() [2/5]

int Gtk::Notebook::insert_page | ( | Widget & | child,
|  | const Glib::ustring & | tab_label,
|  | int | position,
|  | bool | use_mnemonic = `false`
| ) |  |

## ◆ insert_page() [3/5]

int Gtk::Notebook::insert_page | ( | Widget & | child,
|  | int | position
| ) |  |

## ◆ insert_page() [4/5]

int Gtk::Notebook::insert_page | ( | Widget & | child,
|  | Widget & | tab_label,
|  | int | position
| ) |  |

Insert a page into notebook at the given position.

Parameters

  child | The Gtk::Widget to use as the contents of the page.
  tab_label | The Gtk::Widget to be used as the label for the page.
  position | The index (starting at 0) at which to insert the page, or -1 to append the page after all other pages.

## ◆ insert_page() [5/5]

int Gtk::Notebook::insert_page | ( | Widget & | child,
|  | Widget & | tab_label,
|  | Widget & | menu_label,
|  | int | position
| ) |  |

Insert a page into notebook at the given position, specifying the widget to use as the label in the popup menu.

Parameters

  child | The Gtk::Widget to use as the contents of the page.
  tab_label | The Gtk::Widget to be used as the label for the page..
  menu_label | The widget to use as a label for the page-switch menu.
  position | The index (starting at 0) at which to insert the page, or -1 to append the page after all other pages.

## ◆ next_page()

void Gtk::Notebook::next_page | ( |  | ) |

Switches to the next page.

Nothing happens if the current page is the last page.

## ◆ operator=() [1/2]

Notebook& Gtk::Notebook::operator= | ( | const Notebook & |  | ) |
| delete

## ◆ operator=() [2/2]

Notebook& Gtk::Notebook::operator= | ( | Notebook && | src | ) |
| noexcept

## ◆ page_num()

int Gtk::Notebook::page_num | ( | const Widget & | child | ) | const

Finds the index of the page which contains the given child widget.

Parameters

  child | A `Gtk::Widget`.

Returns
  The index of the page containing child, or -1 if child is not in the notebook.

## ◆ popup_disable()

void Gtk::Notebook::popup_disable | ( |  | ) |

Disables the popup menu.

## ◆ popup_enable()

void Gtk::Notebook::popup_enable | ( |  | ) |

Enables the popup menu.

If the user clicks with the right mouse button on the tab labels, a menu with all the pages will be popped up.

## ◆ prepend_page() [1/5]

int Gtk::Notebook::prepend_page | ( | Widget & | child | ) |

## ◆ prepend_page() [2/5]

int Gtk::Notebook::prepend_page | ( | Widget & | child,
|  | const Glib::ustring & | tab_label,
|  | bool | use_mnemonic = `false`
| ) |  |

## ◆ prepend_page() [3/5]

int Gtk::Notebook::prepend_page | ( | Widget & | child,
|  | const Glib::ustring & | tab_label,
|  | const Glib::ustring & | menu_label,
|  | bool | use_mnemonic
| ) |  |

## ◆ prepend_page() [4/5]

int Gtk::Notebook::prepend_page | ( | Widget & | child,
|  | Widget & | tab_label
| ) |  |

Prepends a page to notebook.

Parameters

  child | The Gtk::Widget to use as the contents of the page.
  tab_label | The Gtk::Widget to be used as the label for the page.

## ◆ prepend_page() [5/5]

int Gtk::Notebook::prepend_page | ( | Widget & | child,
|  | Widget & | tab_label,
|  | Widget & | menu_label
| ) |  |

Prepends a page to notebook, specifying the widget to use as the label in the popup menu.

Parameters

  child | The Gtk::Widget to use as the contents of the page.
  tab_label | The Gtk::Widget to be used as the label for the page.
  menu_label | The widget to use as a label for the page-switch menu.

## ◆ prev_page()

void Gtk::Notebook::prev_page | ( |  | ) |

Switches to the previous page.

Nothing happens if the current page is the first page.

## ◆ property_enable_popup() [1/2]

Glib::PropertyProxy< bool > Gtk::Notebook::property_enable_popup | ( |  | ) |

If `true`, pressing the right mouse button on the notebook shows a page switching menu.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_enable_popup() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Notebook::property_enable_popup | ( |  | ) | const

If `true`, pressing the right mouse button on the notebook shows a page switching menu.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_group_name() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Notebook::property_group_name | ( |  | ) |

Group name for tab drag and drop.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_group_name() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Notebook::property_group_name | ( |  | ) | const

Group name for tab drag and drop.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_page() [1/2]

Glib::PropertyProxy< int > Gtk::Notebook::property_page | ( |  | ) |

The index of the current page.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_page() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Notebook::property_page | ( |  | ) | const

The index of the current page.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pages()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gio::ListModel> > Gtk::Notebook::property_pages | ( |  | ) | const

A selection model with the pages.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_scrollable() [1/2]

Glib::PropertyProxy< bool > Gtk::Notebook::property_scrollable | ( |  | ) |

If `true`, scroll arrows are added if there are too many pages to fit.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_scrollable() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Notebook::property_scrollable | ( |  | ) | const

If `true`, scroll arrows are added if there are too many pages to fit.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_border() [1/2]

Glib::PropertyProxy< bool > Gtk::Notebook::property_show_border | ( |  | ) |

Whether the border should be shown.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_border() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Notebook::property_show_border | ( |  | ) | const

Whether the border should be shown.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_tabs() [1/2]

Glib::PropertyProxy< bool > Gtk::Notebook::property_show_tabs | ( |  | ) |

Whether tabs should be shown.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_tabs() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Notebook::property_show_tabs | ( |  | ) | const

Whether tabs should be shown.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_tab_pos() [1/2]

Glib::PropertyProxy< PositionType > Gtk::Notebook::property_tab_pos | ( |  | ) |

Which side of the notebook holds the tabs.

Default value: Gtk::PositionType::TOP

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_tab_pos() [2/2]

Glib::PropertyProxy_ReadOnly< PositionType > Gtk::Notebook::property_tab_pos | ( |  | ) | const

Which side of the notebook holds the tabs.

Default value: Gtk::PositionType::TOP

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ remove_page() [1/2]

void Gtk::Notebook::remove_page | ( | int | page_number = `0` | ) |

Removes a page from the notebook given its index in the notebook.

Parameters

  page_number | The index of a notebook page, starting from 0. If -1, the last page will be removed.

## ◆ remove_page() [2/2]

void Gtk::Notebook::remove_page | ( | Widget & | child | ) |

## ◆ reorder_child()

void Gtk::Notebook::reorder_child | ( | Widget & | child,
|  | int | position
| ) |  |

Reorders the page containing child, so that it appears in position position.

If position is greater than or equal to the number of children in the list or negative, child will be moved to the end of the list.

Parameters

  child | The child to move.
  position | The new position, or -1 to move to the end.

## ◆ set_action_widget()

void Gtk::Notebook::set_action_widget | ( | Widget * | widget,
|  | PackType | pack_type = `PackType::START`
| ) |  |

Sets widget as one of the action widgets.

Depending on the pack type the widget will be placed before or after the tabs. You can use a `Gtk::Box` if you need to pack more than one widget on the same side.

Parameters

  widget | A `Gtk::Widget`.
  pack_type | Pack type of the action widget.

## ◆ set_current_page()

void Gtk::Notebook::set_current_page | ( | int | page_number | ) |

Switches to the page number page_number.

Note that due to historical reasons, GtkNotebook refuses to switch to a page unless the child widget is visible. Therefore, it is recommended to show child widgets before adding them to a notebook.

Parameters

  page_number | Index of the page to switch to, starting from 0. If negative, the last page will be used. If greater than the number of pages in the notebook, nothing will be done.

## ◆ set_group_name()

void Gtk::Notebook::set_group_name | ( | const Glib::ustring & | group_name | ) |

Sets a group name for notebook.

Notebooks with the same name will be able to exchange tabs via drag and drop. A notebook with a `nullptr` group name will not be able to exchange tabs with any other notebook.

Parameters

  group_name | The name of the notebook group, or `nullptr` to unset it.

## ◆ set_menu_label()

void Gtk::Notebook::set_menu_label | ( | Widget & | child,
|  | Widget & | menu_label
| ) |  |

Changes the menu label for the page containing child.

Parameters

  child | The child widget.
  menu_label | The menu label, or `nullptr` for default.

## ◆ set_menu_label_text()

void Gtk::Notebook::set_menu_label_text | ( | Widget & | child,
|  | const Glib::ustring & | menu_text
| ) |  |

Creates a new label and sets it as the menu label of child.

Parameters

  child | The child widget.
  menu_text | The label text.

## ◆ set_scrollable()

void Gtk::Notebook::set_scrollable | ( | bool | scrollable = `true` | ) |

Sets whether the tab label area will have arrows for scrolling if there are too many tabs to fit in the area.

Parameters

  scrollable | `true` if scroll arrows should be added.

## ◆ set_show_border()

void Gtk::Notebook::set_show_border | ( | bool | show_border = `true` | ) |

Sets whether a bevel will be drawn around the notebook pages.

This only has a visual effect when the tabs are not shown.

Parameters

  show_border | `true` if a bevel should be drawn around the notebook.

## ◆ set_show_tabs()

void Gtk::Notebook::set_show_tabs | ( | bool | show_tabs = `true` | ) |

Sets whether to show the tabs for the notebook or not.

Parameters

  show_tabs | `true` if the tabs should be shown.

## ◆ set_tab_detachable()

void Gtk::Notebook::set_tab_detachable | ( | Widget & | child,
|  | bool | detachable = `true`
| ) |  |

Sets whether the tab can be detached from notebook to another notebook or widget.

Note that two notebooks must share a common group identificator (see set_group_name()) to allow automatic tabs interchange between them.

If you want a widget to interact with a notebook through DnD (i.e.: accept dragged tabs from it) it must be set as a drop destination and accept the target “GTK_NOTEBOOK_TAB”. The notebook will fill the selection with a GtkWidget** pointing to the child widget that corresponds to the dropped tab.

Note that you should use detach_tab() instead of remove_page() if you want to remove the tab from the source notebook as part of accepting a drop. Otherwise, the source notebook will think that the dragged tab was removed from underneath the ongoing drag operation, and will initiate a drag cancel animation.

[C example ellipted]

If you want a notebook to accept drags from other widgets, you will have to set your own DnD code to do it.

Parameters

  child | A child `Gtk::Widget`.
  detachable | Whether the tab is detachable or not.

## ◆ set_tab_label()

void Gtk::Notebook::set_tab_label | ( | Widget & | child,
|  | Widget & | tab_label
| ) |  |

Changes the tab label for child.

If `nullptr` is specified for tab_label, then the page will have the label “page N”.

Parameters

  child | The page.
  tab_label | The tab label widget to use, or `nullptr` for default tab label.

## ◆ set_tab_label_text()

void Gtk::Notebook::set_tab_label_text | ( | Widget & | child,
|  | const Glib::ustring & | tab_text
| ) |  |

Creates a new label and sets it as the tab label for the page containing child.

Parameters

  child | The page.
  tab_text | The label text.

## ◆ set_tab_pos()

void Gtk::Notebook::set_tab_pos | ( | PositionType | pos | ) |

Sets the edge at which the tabs are drawn.

Parameters

  pos | The edge to draw the tabs at.

## ◆ set_tab_reorderable()

void Gtk::Notebook::set_tab_reorderable | ( | Widget & | child,
|  | bool | reorderable = `true`
| ) |  |

Sets whether the notebook tab can be reordered via drag and drop or not.

Parameters

  child | A child `Gtk::Widget`.
  reorderable | Whether the tab is reorderable or not.

## ◆ signal_page_added()

Glib::SignalProxy<void(Widget*, guint)> Gtk::Notebook::signal_page_added | ( |  | ) |

Slot Prototype:
  `void on_my_page_added(Widget* page, guint page_num)`

Flags: Run Last

the signal_page_added() signal is emitted in the notebook right after a page is added to the notebook.

Parameters

  page | The child `Gtk::Widget` affected.
  page_num | The new page number for page.

## ◆ signal_page_removed()

Glib::SignalProxy<void(Widget*, guint)> Gtk::Notebook::signal_page_removed | ( |  | ) |

Slot Prototype:
  `void on_my_page_removed(Widget* page, guint page_num)`

Flags: Run Last

the signal_page_removed() signal is emitted in the notebook right after a page is removed from the notebook.

Parameters

  page | The child `Gtk::Widget` affected.
  page_num | The page page number.

## ◆ signal_page_reordered()

Glib::SignalProxy<void(Widget*, guint)> Gtk::Notebook::signal_page_reordered | ( |  | ) |

Slot Prototype:
  `void on_my_page_reordered(Widget* page, guint page_num)`

Flags: Run Last

the signal_page_reordered() signal is emitted in the notebook right after a page has been reordered.

Parameters

  page | The child `Gtk::Widget` affected.
  page_num | The new page number for page.

## ◆ signal_switch_page()

Glib::SignalProxy<void(Widget*, guint)> Gtk::Notebook::signal_switch_page | ( |  | ) |

Slot Prototype:
  `void on_my_switch_page(Widget* page, guint page_number)`

Flags: Run Last

Emitted when the user or a function changes the current page.

Parameters

  page | The new current page.
  page_number | The index of the page.

## Friends And Related Function Documentation

## ◆ wrap()

Gtk::Notebook * wrap | ( | GtkNotebook * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.